//var GpxFile_polys=[];
var GpxFile_circles=[];  //seznam ID vsech kruhu
var GpxFile_markers=[];  //seznam ID vsech bodu
var aTrack=[];           //pole jednotlivych bodu stopy: aTrack.push(TrkPt)
var graphDataHT=[[]];   //data pro graf nadmorska vyska-cas
var graphDataST=[[]];   //data pro graf rychlost-cas
var graphDataDT=[[]];   //data pro graf vzdalenost-cas
var GpxColor=0;         //barva stopy (0 znamena nepouzito)
var GpxWeight=4;        //sirka stopy
var GpxColorBold="lime";//barva stopy
var GpxWeightBold=6;    //sirka stopy
var GpxPoly;            //zobrazena stopa, aby ji slo menit vlastnosti (barvu, tloustku cary)
var GpxLine;            //zvyraznena cara mezi sousednimi body
var Xindex=-1;
var bGpxSave=false;     //priznak pozadovaneho ulozeni nastaveni

function GpxFileTrackAnalyseClean(){
  //aTrack=[];           //pole jednotlivych bodu stopy: aTrack.push(TrkPt)
  graphDataHT=[[]];   //data pro graf nadmorska vyska-cas
  graphDataST=[[]];   //data pro graf rychlost-cas
  graphDataDT=[[]];   //data pro graf vzdalenost-cas
  Xindex=-1;
}
function formaTimeDifference(rozdil){ //vstupni hodnota rozdilu je v sekundach
  //rozdil=dt1.getUTCSeconds()-dt2.getUTCSeconds();
  if(rozdil<0) rozdil*=-1;
  hour=Math.floor(rozdil/3600);
  rozdil-=(hour*3600);
  min=Math.floor(rozdil/60);
  rozdil-=(min*60);
  return(hour+' h, '+min+' m, '+rozdil+' s');
}

function calcDist(lat1,lon1, lat2,lon2){
  dLat=lat1-lat2;
  dLon=lon1-lon2;
  return(Math.sqrt(dLat*dLat+dLon*dLon));
}

function addTrkPt(idx){  //definice bodu parsovaneho ze stopy
  this.idx=idx;          //poradove cislo bodu
  this.idxSeg=-1;        //poradove cislo segmentu
  this.lat=0;            //souradnice
  this.lon=0;
  this.ele=0;            //nadmorska vyska
  this.time=0;           //datum a cas
  this.dist=0;           //vzdalenost
  //---- vypocitavane hodnoty od predchoziho bodu
  this.dDist=0;          //vzdalenost
  this.speed=0;          //rychlost
  this.dTime=0;          //cas
  this.dEle=0;           //stoupani, klesani
  this.flagEle=0;        //0=rovina, -1=klesani, 1=stoupani
}

function calculateDeltaValues(n){
  var latlon1,latlon2;
  aTrack[n].speed=0;
  if(n>0){
    latlon1=L.latLng(aTrack[n-1].lat,aTrack[n-1].lon);
    latlon2=L.latLng(aTrack[n].lat,aTrack[n].lon);
    aTrack[n].dEle=aTrack[n].ele-aTrack[n-1].ele;
    aTrack[n].dDist=latlon2.distanceTo(latlon1);     //v metrech
    aTrack[n].dist=aTrack[n-1].dist+aTrack[n].dDist; //v metrech
    if(aTrack[n].dDist>0.5 && aTrack[n].dTime>0){
      aTrack[n].speed=aTrack[n].dDist/aTrack[n].dTime*3.6; //v hm/h
    }
  }
}

function getInnerHtmlByName(aXml,name,implicit){
  var elem=aXml.getElementsByTagName(name);
  if(elem.length==0) return(implicit);
  return(aXml.getElementsByTagName(name)[0].innerHTML);
}

function parseGpx(file,bEdit=false){
  //bEdit signalizuje, zda ma byt pridavana cara editovatelna
  //zkontrolujeme, zda je to gpx soubor
  //alert('Nacteni GPX souboru: '+file.name);
  //if((GpxFile_poly!=undefined)){ GpxFile_poly.remove(map);}
  var lat,lon;
  GpxColor=0;
  var bTrack=false;
  var reader=new FileReader();
  reader.readAsText(file,'UTF-8'); //nacteme soubor (predpokladame v utf-8)
  var xml='';
  aTrack=[];                       //vymazeme pripadnou predchozi stopu
  var ele_dist=($('#iSettingsTilt').val()-0)/100; //prevedeme z procent na cislo
  reader.onload=readerEvent => {
    xml=readerEvent.target.result; //toto je nacteny obsah
    //console.log("-nacteno---\n"+xml);
    var parser=new DOMParser();
    var gpx=parser.parseFromString(xml, "text/xml");
    var aLatLon=[];
    var aSeg=gpx.getElementsByTagName("trkseg"); //nacte vsechny segmenty <trksek>
    //pokud je tu stopa, zobrazime ji
    var idxSeg=0;
    var TrkPtOld=addTrkPt(0);
    var eleMin=99999;
    var eleMax=-99999;
    var elePlus=0;        //nastoupana vzdalenost
    var eleMinus=0;       //naklesana vzdalenost
    var speedMove=0;      //soucet dislcich rychlosti
    var speedTime=0;      //soucet casu v pohybu
    var speedMax=0;       //maximalni rychlost
    var speedEnabled=$('#iSettingsSpeed').val()-0; //maximalni povolena rychlost
    var distAll=0;        //celkova vzdalenost
    var distUp=0;         //vzdalenost do kopce
    var distDown=0;       //vzdalenost z kopce
    var distLevel=0;      //vzdalenost po rovine
    var distReal=0;
    var distAllTime=0;    //cas pohybu
    var distUpTime=0;
    var distDownTime=0;
    var distLivelTime=0;
    var timePause=0;      //cas bez pohybu
    var timeUp=0;         //cas stoupani
    var timeDown=0;       //cas klesani
    var timeLevel=0;      //cas po rovine
    var sName='';         //jmeno stopy
    var nReduce=0;        //pocet redukovanych bodu
    var bEle=false;       //priznak existujici nadmorske vysky
    var bTime=false;      //priznak existujiciho casu

    //var latlon1,latlon2;
    var graph=document.getElementById('iGpxFormDivTrackGraphHT');
//    //var graphDataSD=[[]];   //data pro graf rychlost-vzdalenost
    var graphXaxis=[];      //data pro rychlost v ose X
    //vymazat stara data, pokud jsou nejaka
    GpxFileTrackAnalyseClean();

    n=0;
    var a=gpx.getElementsByTagName("trk");
    if(a.length==0){ bTrack=false; }//neni to stopa (trk)
    else{
      sName=getInnerHtmlByName(a[0],"name","Neznámé jméno");
      for(var seg of aSeg){ //projdeme vsechny segmenty
        var aTrkpt=seg.getElementsByTagName("trkpt"); //nacteme vsechny body segmentu
        for(var wpt of aTrkpt){ //z kazdeho bodu nacteme lat a lon hodnotu
          lat=wpt.getAttribute("lat")-0;
          lon=wpt.getAttribute("lon")-0;
          var latlon=[lat,lon];
          aLatLon.push(latlon);
          bTrack=true;
          //pridame prazdny bod stopy a zapiseme jeho hotnoty pro analyzu stopy
          aTrack.push(new addTrkPt(n));
          aTrack[n].idxSeg=idxSeg;
          aTrack[n].lat=lat;
          aTrack[n].lon=lon;
          latlon2=L.latLng(lat,lon);
          //### pokud neni nadmorska vyska, neni to skutecna stopa z GPS ??
          aTrack[n].ele=getInnerHtmlByName(wpt,"ele",-1)-0;
          if(aTrack[n].ele!=-1) bEle=true;
    //console.log(n+', ele: '+aTrack[n].ele);
          //porovnavat musime jako cislo, ne jako string
          if(+eleMin>+aTrack[n].ele) eleMin=aTrack[n].ele;
          if(+eleMax<+aTrack[n].ele) eleMax=aTrack[n].ele;
          //pro doplneni zony (ted natvrdo 00:00) jsou webove sluzby, ...
          //https://stackoverflow.com/questions/16086962/how-to-get-a-time-zone-from-a-location-using-latitude-and-longitude-coordinates
          ele=getInnerHtmlByName(wpt,"time","");
          if(ele!=""){
            bTime=true;
            //ignorujeme sousedni body se stejnym casem (napr. ve dvou sousednich segmentech)
            //if(n>0 && ele==aTrack[n].time){
            //  aTrack.pop();
            //  continue;
            //}
            //parse automaticky upravi UTC cas na lokalni?
            aTrack[n].time=Date.parse(ele.trim());
          }
          else aTrack[n].time=0;
          if(n>0) aTrack[n].dTime=Math.floor((aTrack[n].time-TrkPtOld.time)/1000); //rozdil casu v sekundach
          calculateDeltaValues(n); //dEle, dDist, dist, speed
          //pokud je rychlost prilis velika, asi to znamena, ze GPS byla pred
          //chvili zapnuta a az ted ma FIX. Predchozi body se stejnym casem
          //a nadmorskou vyskou smazeme
          if(aTrack[n].speed>speedEnabled && speedEnabled!=0){
            for(var n2=n-2; n2>1; n2--){
                /*
                console.log('mazani bodu n-1');
                console.log('   bod n-3:'+(n-3)+': lat='+aTrack[n-3].lat+': lon='+aTrack[n-3].lon+', ele='+aTrack[n-3].ele+', speed='+aTrack[n-3].speed);
                console.log('   bod n-2:'+(n-2)+': lat='+aTrack[n-2].lat+': lon='+aTrack[n-2].lon+', ele='+aTrack[n-2].ele+', speed='+aTrack[n-2].speed);
                console.log('   bod n-1:'+(n-1)+': lat='+aTrack[n-1].lat+': lon='+aTrack[n-1].lon+', ele='+aTrack[n-1].ele+', speed='+aTrack[n-1].speed);
                console.log('   bod n:  '+(n)+': lat='+aTrack[n].lat+': lon='+aTrack[n].lon+', ele='+aTrack[n].ele+', speed='+aTrack[n].speed);
                */
              aTrack.splice(n-1,1); //smazeme jeden prvek pole
              graphDataHT.splice(n-1);
              graphDataST.splice(n-1);
              graphDataDT.splice(n-1);
              graphXaxis.splice(n-1);
              n--;
              nReduce++;
              calculateDeltaValues(n); //a znovu vypocteme rozdilove hodnoty
                /*
                console.log('Po smazani');
                console.log('   bod n-3:'+(n-3)+': lat='+aTrack[n-3].lat+': lon='+aTrack[n-3].lon+', ele='+aTrack[n-3].ele+', speed='+aTrack[n-3].speed);
                console.log('   bod n-2:'+(n-2)+': lat='+aTrack[n-2].lat+': lon='+aTrack[n-2].lon+', ele='+aTrack[n-2].ele+', speed='+aTrack[n-2].speed);
                console.log('   bod n-1:'+(n-1)+': lat='+aTrack[n-1].lat+': lon='+aTrack[n-1].lon+', ele='+aTrack[n-1].ele+', speed='+aTrack[n-1].speed);
                console.log('   bod n:  '+(n)+': lat='+aTrack[n].lat+': lon='+aTrack[n].lon+', ele='+aTrack[n].ele+', speed='+aTrack[n].speed);
                */
              if(aTrack[n-2].lat.toFixed(6)!=aTrack[n-1].lat.toFixed(6) || aTrack[n-2].lon.toFixed(6)!=aTrack[n-1].lon.toFixed(6)
                /*|| aTrack[n2].ele!=aTrack[n2+1].ele*/){
                //smazeme jeste jeden bod
                aTrack.splice(n-1,1);
                graphDataHT.splice(n-1);
                graphDataST.splice(n-1);
                graphDataDT.splice(n-1);
                graphXaxis.splice(n-1);
                n--;
                nReduce++;
                calculateDeltaValues(n); //a znovu vypocteme rozdilove hodnoty
                //console.log('------ konec smazani');
                break;
              }
            }
          }

    //console.log(n+', dTime: '+aTrack[n].dTime);
          if(n>0){
            if(aTrack[n].dDist<1){ //vypocty bez pohybu
              timePause+=aTrack[n].dTime; //cas bez pohybu
            }
            else{                 //vypocty za pohybu
              distAll+=aTrack[n].dDist;   //v metrech
              distReal+=Math.sqrt(aTrack[n].dDist*aTrack[n].dDist+aTrack[n].dEle*aTrack[n].dEle);
              distAllTime+=aTrack[n].dTime;
    //console.log(n+', speed: '+aTrack[n].speed);
              if(+speedMax<+aTrack[n].speed) speedMax=aTrack[n].speed;
              speedMove+=aTrack[n].dDist;
              speedTime+=aTrack[n].dTime;
            }
            f=aTrack[n].dEle/aTrack[n].dDist;
            if(f<-ele_dist){         //vypocty pri klesani
              eleMinus+=aTrack[n].dEle;
              distDown+=aTrack[n].dDist;
              timeDown+=aTrack[n].dTime;
    //console.log(n+', timeDown: '+timeDown);
            }
            else if(f>ele_dist){    //vypocty pri stopani
              elePlus+=aTrack[n].dEle;
              distUp+=aTrack[n].dDist;
              timeUp+=aTrack[n].dTime;
            }
            else{               //vypocty po rovine
              distLevel+=aTrack[n].dDist;
              timeLevel+=aTrack[n].dTime;
            }
          }
          TrkPtOld=aTrack[n];
          //latlon1=latlon2;
          //doplnime data pro grafy v zavislosti na case
          graphDataHT.push([dateFormat(aTrack[n].time,"yyyy-mm-dd'T'HH:MM:ss'.000Z'"),aTrack[n].ele]);
          graphDataST.push([dateFormat(aTrack[n].time,"yyyy-mm-dd'T'HH:MM:ss'.000Z'"),aTrack[n].speed.toFixed(2)]);
          d=aTrack[n].dist/1000;   //v km
          graphDataDT.push([dateFormat(aTrack[n].time,"yyyy-mm-dd'T'HH:MM:ss'.000Z'"),d.toFixed(3)]);
          graphXaxis.push([aTrack[n].speed.toFixed(2)]);
          n++;
          //if(n>12) break;
        }
        idxSeg++;
      }
      if(bTrack){
        //console.log('count: '+aTrack.length);
        if(nReduce>0)  $('#iGpxFormTdCount').html((n+nReduce)+' (smazáno: '+nReduce+')');
        else           $('#iGpxFormTdCount').html(n);
        //--- casy
        $('#iGpxFormTdTmStart').html(dateFormat(aTrack[0].time,"dd.mm.yyyy HH:MM:ss"));
        $('#iGpxFormTdTmEnd').html(dateFormat(aTrack[n-1].time,"dd.mm.yyyy HH:MM:ss"));
        $('#iGpxFormTdTmTotal').html(
          formaTimeDifference(Math.floor((aTrack[n-1].time-aTrack[0].time)/1000))
          );
        $('#iGpxFormTdTmMove').html(formaTimeDifference(distAllTime));
        $('#iGpxFormTdTmStop').html(formaTimeDifference(timePause));
        $('#iGpxFormTdTmUp').html(formaTimeDifference(timeUp));
        $('#iGpxFormTdTmDown').html(formaTimeDifference(timeDown));
        $('#iGpxFormTdTmLevel').html(formaTimeDifference(timeLevel));

        //--- nadmorske vysky
        $('#iGpxFormTdHighStart').html((aTrack[0].ele-0).toFixed(2)+' m');
        $('#iGpxFormTdHighEnd').html((aTrack[n-1].ele-0).toFixed(2)+' m');
        $('#iGpxFormTdHighDelA').html((aTrack[n-1].ele-aTrack[0].ele).toFixed(2)+' m');
        $('#iGpxFormTdHighMin').html((eleMin-0).toFixed(2)+' m');
        $('#iGpxFormTdHighMax').html((eleMax-0).toFixed(2)+' m');
        f=eleMax-eleMin;
        $('#iGpxFormTdHighDelB').html(f.toFixed(2)+' m');
        $('#iGpxFormTdHighUp').html(elePlus.toFixed(2)+' m');
        $('#iGpxFormTdHighDown').html(-eleMinus.toFixed(2)+' m');
        f=elePlus+eleMinus;
        $('#iGpxFormTdHighDelC').html(f.toFixed(2)+' m');
        //--- rychlosti
        if(bTime){
          $('#iGpxFormTdSpeedMax').html(speedMax.toFixed(2)+' km/h');
          d=(aTrack[n-1].time-aTrack[0].time)/1000;   //v sekundac misto milisekund
          d=distAll/d*3.6;  // z m/s na km/h
          $('#iGpxFormTdSpeedAvg').html(d.toFixed(2)+' km/h');
          d=speedMove/speedTime*3.6;  // z m/s na km/h
          $('#iGpxFormTdSpeedMove').html(d.toFixed(2)+' km/h');
          d=distUp/timeUp*3.6;  // z m/s na km/h
          //console.log('timeUp: '+timeUp+', '+d);
          $('#iGpxFormTdSpeedUp').html(d.toFixed(2)+' km/h');
          d=distDown/timeDown*3.6;  // z m/s na km/h
          //console.log('timeDown: '+timeDown+', '+d);
          $('#iGpxFormTdSpeedDown').html(d.toFixed(2)+' km/h');
          d=distLevel/timeLevel*3.6;  // z m/s na km/h
          //console.log('timeLevel: '+timeLevel+', '+d);
          $('#iGpxFormTdSpeedLevel').html(d.toFixed(2)+' km/h');
        }
        else{  //pokud neni cas, nemaji rychlosti
          $('#iGpxFormTdSpeedMax').html('');
          $('#iGpxFormTdSpeedAvg').html('');
          $('#iGpxFormTdSpeedMove').html('');
          $('#iGpxFormTdSpeedUp').html('');
          $('#iGpxFormTdSpeedDown').html('');
          $('#iGpxFormTdSpeedLevel').html('');
        }
        //--- vzdalenosti
      //console.log('timeDown: '+timeDown);
        d=distAll/1000;  $('#iGpxFormTdDist').html(d.toFixed(3)+' km');
        d=distReal/1000;  $('#iGpxFormTdDistReal').html(d.toFixed(3)+' km');
        d=distUp/1000;  $('#iGpxFormTdDistUp').html(d.toFixed(3)+' km');
        d=distDown/1000;  $('#iGpxFormTdDistDown').html(d.toFixed(3)+' km');
        d=distLevel/1000;  $('#iGpxFormTdDistLevel').html(d.toFixed(3)+' km');
        $('#iGpxFormDivTrackTable').removeClass('cDisable');
        $('#iGpxButTable').removeClass('cDisable');
        //----
        ///// parametry pro zobrazeni grafu
        //priklad se zdvojenou osou x, na druhe urovni jsou hodnoty v "grafu"
        //https://echarts.apache.org/examples/en/editor.html?c=doc-example/candlestick-axisPointer
        //https://echarts.apache.org/en/option.html
        colors=['#5470C6', '#91CC75','#A66666'];
        optionGraph={
          title : {  text: sName },
          color: colors,
          animation: false,
          tooltip: {
            trigger: 'axis',
            axisPointer: {
              type: 'cross'
            },
            position: function (pos, params, el, elRect, size) {
              var obj = {top: 10};
                //60 bodu zleva nebo zprava podle toho, kde je kurzor
                obj[['left','right'][+(pos[0]<size.viewSize[0]/2)]]=60;
                return obj;
            },
          },
          axisPointer: {    //pres obe casti gratu
            link: {xAxisIndex: 'all'},
            //label: {
            //  backgroundColor: '#777'
            //}
          },
          grid: [  //rozdeleni grafu na dve casti, nahore nadmorska vyska, dole rychlost
            {
              left: '10%',
              right: '6%',
              height: '40%'
            }
            ,{
              left: '10%',
              right: '6%',
              bottom: '12%',
              height: '20%'
            }
          ],
          formatter: function(par){
            //console.log(par);
            var s=par[0].value[0].replace('T','.');
            var a=s.split('.');
            idxH=0; idxS=0; idxD=0;
            //pripravime hodnotu indexu pro kliknuti mysi
            Xindex=par[0].dataIndex;  //index je v grafu je od 1, ne od 0 !!
            //pokud je pozadovane okamzite zobrazeni podrobnosti, zobrazime je
            if($('#iSettingsClick').is(":checked")) GpxFillDetail();
            for(i=0; i<3; i++){
              if(par[i].seriesName=="Vzdalenost") idxD=i;
              if(par[i].seriesName=="Rychlost") idxS=i;
              if(par[i].seriesName=="Vyska") idxH=i;
            }
            return('<p class="cGpxFileGraphToolP">'+a[0]+'<br/>'+a[1]
              +'<br/>Pořadí bodu: '+par[0].dataIndex+'</p>'  //index je od 1, ne od 0
              +par[idxH].marker+' '+(par[idxH].value[1]-0).toFixed(2)+' m<br/>'
              //i kdyz jsou data v poradi rychlost - vzdalenost, v poli jsou opacne
              +par[idxD].marker+' '+(par[idxD].value[1]-0).toFixed(2)+" km<br/>"
              +par[idxS].marker+' '+(par[idxS].value[1]-0).toFixed(2)+" km/h"
              );
          },
          xAxis: [
            {              // x osa pro horni cast grafu
              type: 'time',
              scale: true,
              boundaryGap : false,
              axisLine: {onZero: false},
              min: 'dataMin',
              max: 'dataMax',
              axisPointer: { z: 100 }
            },
            {               //x osa pro spodni cast grafu
              type: 'time',
              gridIndex: 1,
              scale: true,
              boundaryGap : false,
              axisLine: {onZero: false},
              axisTick: {show: false},
              //splitLine: {show: false},
              axisLabel: {show: false},
              min: 'dataMin',
              max: 'dataMax',
            }
          ],
          yAxis: [
            {          //osa vlevo pro nadmorskou vysku
              name: 'Výška [m]',
              scale: true,
              min: Math.floor(eleMin),
              max: Math.ceil(eleMax),
              splitArea: { show: true },
              axisLine:{
                show: true,
                lineStyle:{ color: colors[0]}
              },
            },
            {         //osa vlevo dole pro rychlost
              scale: true,
              name: "Rychlost [km/h]",
              gridIndex: 1,
              axisLabel: {show: true},
              axisLine: {show: false},
              axisTick: {show: false},
              splitLine: {show: true},
              min: 0,
              max: Math.ceil(speedMax),
              splitNumber: 1,
              axisLine:{
                show: true,
                lineStyle:{ color: colors[1]}
              },
            },
            {          //osa vpravo pro celkovou vzdalenost
              name:"Vzdálenost\n[km]",
              gridIndex:0,
              position:'right',
              min: 0,
              max: Math.ceil(distAll/1000),
              scale: true,
              axisLine:{
                show: true,
                lineStyle:{ color: colors[2]}
              },
              splitLine: {show: false},
            }
          ],
          dataZoom: [
            {
              type: 'inside',
              xAxisIndex: [0, 1],
              start: 0,
              end: n-1
            },
            {
              show: true,
              xAxisIndex: [0, 1],
              type: 'slider',
              top: '90%',
              height: '8%',
              start: 0,
              end: n-1
            }
          ],
          series: [
            {
              name: 'Vyska',
              type: 'line',
              symbol:'none',
              color:colors[0],
              data: graphDataHT,
              xAxisIndex: 0,
              yAxisIndex: 0,
              areaStyle: {},
            },
            {
              name: 'Rychlost',
              type: 'line',
              symbol:'none',
              color:colors[1],
              xAxisIndex: 1,
              yAxisIndex: 1,
              data: graphDataST
            },
            {
              name: 'Vzdalenost',
              type: 'line',
              symbol:'none',
              color: colors[2],
              data: graphDataDT,
              xAxisIndex: 0,
              yAxisIndex: 2,
            }
          ]
      };
      var graphHT=echarts.init(graph);
      optionGraph && graphHT.setOption(optionGraph);
      if(bTime){  //pokud je cas, zobrazime grafy
        $('#iGpxFormDivTrackGraph').removeClass('cDisable');
        $('#iGpxButGraph').removeClass('cDisable');
      }
      else{
        $('#iGpxFormDivTrackGraph').addClass('cDisable');
        $('#iGpxButGraph').addClass('cDisable');
      }

      var zr=graphHT.getZr();
      zr.on('click', function (params) {
        GpxFillDetail();
      });
      GpxColor="rgb(100,100,255)";
      $("#iGpxDetailIdxFrom").attr({ //nastavime hodnoty max v <input>
        "max":(aTrack.length-1)
      });

    }
    else{ //zakazeme prislusna okna
      $('#iGpxFormDivTrackTable').addClass('cDisable');
      $('#iGpxFormDivTrackGraph').addClass('cDisable');
      $('#iGpxButTable').addClass('cDisable');
      $('#iGpxButGraph').addClass('cDisable');
    }
  }
    //pokud nejde o stopu, zkusime zpracovat jako (planovanou) trasu
   if(bTrack==false){
      //var rte=gpx.getElementsByTagName("rte");
      var aRtept=gpx.getElementsByTagName("rtept"); //nacteme vsechny body segmentu
      if(aRtept.length>0){
        for(var wpt of aRtept){ //z kazdeho bodu nacteme lat a lon hodnotu
          lat=wpt.getAttribute("lat");
          lon=wpt.getAttribute("lon");
          var latlon=[lat,lon];
          aLatLon.push(latlon);
        }
        bTrack=true;
        GpxColor="rgb(255,100,100)";
      }
    }
    if(GpxColor!=0){    //je tam stopa nebo plánovaná trasa
      saveGpxSettings(); //napred ulozime nastaveni, pro pripad, ze se zmenilo
      if(!bEdit){       //pokud stopa existuje, napred ji vymazeme
        if(typeof GpxPoly!=="undefined") map.removeLayer(GpxPoly);
      }
      //nastavime predvolenou barvu stopy
      if($('#iSettingsColor').val()!=0) GpxColor=$('#iSettingsColor').val();
      $('#iSettingsColor').val(GpxColor); //zapiseme aktualni barvu, aby se prepsala uvodni 0
      //console.log($('#iSettingsColor').val();
      GpxWeight=$('#iSettingsWeight').val();
      GpxPoly=L.polyline(aLatLon, {color: GpxColor, weight: GpxWeight, smoothFactor: 1}).addTo(map);
      //vystredime polyline v mape
      map.fitBounds(GpxPoly.getBounds());
      //GpxFile_polys.push(GpxPoly);
      //pokud neni dostupna promenna drawnItems, nelze upravovat
      if(bEdit){
        if(typeof drawnItems==="undefined"){
          alert("Není dostupná proměnná 'drawnItems', stopu nebude možné upravovat. "
          +"Pro tuto podporu je pořeba upravit soubor 'ggmap.js'");
          //zmenit radek 969 z:  var drawnItems = new L.FeatureGroup();
          //na:                  drawnItems = new L.FeatureGroup();
          //doplnit radek 25: var drawnItems;
        }
        else{
          if(aLatLon.length>800){
            alert("Stopa má "+aLatLon.length+" bodů. Při grafické editaci může být "
              +"odezva mapy velmi zpomalená.");
          }
          let cells=addFeatureEntry((++lineCounter_), GpxColor, {layer: GpxPoly, layerType: 'polyline'});
          updatePolyline(GpxPoly, cells);
          //do seznamu editovatelnych prvku pridame pred vzdalenost novy td s tlacitkem pro ulozeni
          let tdSave = document.createElement("td");
          cells.desc.parentNode.insertBefore(tdSave, cells.desc)
          tdSave.innerHTML='<div class="cGpxButSave" onclick="saveAsFile('+GpxPoly._leaflet_id+');"></div>';
          drawnItems.addLayer(GpxPoly); //pridame take do editace pres Leaflet plugin draw
        }
      }
    }
    else alert("ERR: Soubor neobsahuje zobrazitelnou stopu nebo trasu.");
  }
}

function stringToFile(str,fileName){
  document.getElementById('iGpxTxt').value=str; //ulozime text do prvku formulare
  var textFile=null;
  var makeTextFile=function(text){
    var data=new Blob([text], {type: 'text/plain'});
    if(textFile!==null){
      window.URL.revokeObjectURL(textFile);
    }
    textFile=window.URL.createObjectURL(data);
    return textFile;
  };
  //var create=document.getElementById('create');
  var txt=document.getElementById('iGpxTxt');
  var link=document.createElement('a');
  link.setAttribute('download', fileName);
  link.href=makeTextFile(txt.value);
  document.body.appendChild(link);
  //pockame na pridani <a> do dokumentu
  window.requestAnimationFrame(function () {
    var event = new MouseEvent('click');
    link.dispatchEvent(event);
    document.body.removeChild(link);
  });
}

function frac(f) { return f % 1;} //necha jen desetinnou cast z cisla
function ssmmddd(lat,lon){ //prevede desetinny format cisla na SS°mm.ddd
  var str;
  if(lat<0){ str='S'; lat=-lat;} else str='N';
  str=str+Math.floor(lat)+'°';  //soubor je v UTF-8, takze ten stupen taky!
  lat=60.*frac(lat);
  str=str+lat.toFixed(3)+', ';
  //lon;
  if(lon<0){ str='W'; lon=-lon;} else str=str+'E';
  str=str+Math.floor(lon)+'°'; //soubor je v UTF-8, takze ten stupen taky!
  lon=60.*frac(lon);
  str=str+lon.toFixed(3);
  return(str);
}

function saveCoords(format){ //ulozi souradnice ve zvolenem formatu
                                //0=CSV, 1=stopa, 2=trasa, 3=CSV ve formaty SS°mm.ddd
  hideGpxSaveForm();
  var id=document.getElementById('iGpxSaveId').text;
  map.eachLayer(function(layer){  //projdeme vsechny layer a najdeme ten spravny podle id
    if(layer._leaflet_id==id){
      var a=layer.getLatLngs();
      if(layer instanceof L.Polygon){
        a=a[0]; //v polygonu je pole poli souradnic, pouzijeme prvni z nich
      }
      if(a.length>1){ //ukladat 1 bod nejde, mozna je to od polygonu
        var sGpx='';
        for(var i=0; i<a.length; i++){
          if(format==0) s=a[i].lat+', '+a[i].lng;
          if(format==1) s='<trkpt lat="'+roundVal(a[i].lat)+'" lon="'+roundVal(a[i].lng)+'"></trkpt>';
          if(format==2) s='<rtept lat="'+roundVal(a[i].lat)+'" lon="'+roundVal(a[i].lng)+'"></rtept>';
          if(format==3) s=ssmmddd(a[i].lat,a[i].lng);
          if(format==4){
                        if(sGpx=='') s=''; else s=',';
                        s=s+'['+roundVal(a[i].lng)+', '+roundVal(a[i].lat)+']';
                        sGpx+=s;
          }
          else sGpx=sGpx+s+"\r\n";
        };
        var dt=new Date();     var year=dt.getFullYear();  var month=dt.getMonth()+1;
        var day=dt.getDate(); var hour=dt.getHours();     var minute=dt.getMinutes();
        var second=dt.getSeconds();
        if(month.toString().length==1){ month='0'+month;}
        if(day.toString().length==1){ day='0'+day;}
        if(hour.toString().length==1){ hour='0'+hour;}
        if(minute.toString().length==1){ minute='0'+minute;}
        if(second.toString().length==1){ second='0'+second;}
        var dateTime = year+'/'+month+'/'+day+' '+hour+':'+minute+':'+second;
        //obalime data, pokud je to potreba
        //jmeno stopy je potreba pro garminy
        if(format==1) sGpx="<trk><trkseg><name>Track from ggmap</name>\r\n"+sGpx+"</trkseg>\r\n</trk>\r\n";
        if(format==2) sGpx="<rte>\r\n"+sGpx+"</rte>\r\n";
        //pro GPX jeste hlavicka a paticka
        if(format==1 || format==2){
          sGpx="<?xml version=\"1.0\" encoding=\"UTF-8\" standalone=\"no\" ?>\r\n"
            +"<gpx xmlns=\"http://www.topografix.com/GPX/1/1\" "
            +"xmlns:gpxx=\"http://www.garmin.com/xmlschemas/GpxExtensions/v3\" "
            +"xmlns:gpxtpx=\"http://www.garmin.com/xmlschemas/TrackPointExtension/v1\" "
            +"creator=\"GeoGet, ggmap, GpxFile\" version=\"1.1\" "
            +"xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" "
            +"xsi:schemaLocation=\"http://www.topografix.com/GPX/1/1 http://www.topografix.com/GPX/1/1/gpx.xsd http://www.garmin.com/xmlschemas/GpxExtensions/v3 http://www.garmin.com/xmlschemas/GpxExtensionsv3.xsd http://www.garmin.com/xmlschemas/TrackPointExtension/v1 http://www.garmin.com/xmlschemas/TrackPointExtensionv1.xsd\">\r\n"
            +"<metadata>\r\n"
            +"  <time>"+year+'-'+month+'-'+day+'T'+hour+':'+minute+':'+second+"Z</time>\r\n"
            +"</metadata>\r\n"
            +sGpx+"</gpx>\r\n";
        }
        if(format==4){
          sGpx="{\"type\":\"FeatureCollection\",\n"
              +"  \"features\":[\n"
              +"    {\n"
              +"      \"id\":\""+dateTime+"-LineString\",\n"
              +"      \"type\":\"Feature\",\n"
              +"      \"geometry\":{\n"
              +"        \"type\":\"LineString\",\n"
              +"        \"coordinates\":["+sGpx+"]\n"
              +"      },\n"
              +"      \"properties\": {\n"
              +"         \"color\":\"cyan\", \"dashArray\":\"10,0\", \"weight\":4,\n"
              +"         \"name\": \"Stopa/trasa uložená z ggMap\"\n"
              +"      }\n"
              +"    }\n"
              +"  ]\n"
              +"}\n";
        }
        //ulozime do souboru
        if(format==0 || format==3) stringToFile(sGpx,'polyline.csv');
        if(format==1) stringToFile(sGpx,'trace.gpx');
        if(format==2) stringToFile(sGpx,'route.gpx');
        if(format==4) stringToFile(sGpx,'lineString.json');
      }
    }
  });
}

function saveAsFile(id,format){
  //zapiseme do formulare hodnotu id
  document.getElementById('iGpxSaveId').text=id;
  //zobrazime formular
  document.getElementById('iGpxSaveForm').style.display='block';
}

function hideGpxSaveForm(){
  document.getElementById('iGpxSaveForm').style.display='none';
}

function getElemCoord(id){ //vraci souradnice (pripadne i polomer) elementu se zadanym id
var s="";
  map.eachLayer(function(layer){  //projdeme vsechny layer a najdeme ten spravny podle id
    if(layer._leaflet_id==id){
      var a=layer.getLatLng();
      var r=-1;
      if(layer instanceof L.Circle){ r=layer.getRadius();} //polomer v metrech
      s=a.lat.toFixed(6)+" "+a.lng.toFixed(6);
      if(r>=0) s=s+" "+r.toFixed(2);
      s=s+"\r\n";
      return(s);
    }
  });
  return(s); //nenalezeno, asi byl element vymazan
}

function saveCircles(){
var s='';
  for(i=0; i<GpxFile_circles.length; i++){
    s=s+getElemCoord(GpxFile_circles[i]);
  }
  stringToFile(s,"Circles.txt");
}

function saveMarkers(){
var s='';
  for(i=0; i<GpxFile_markers.length; i++){
    s=s+getElemCoord(GpxFile_markers[i]);
  }
  stringToFile(s,"Markers.txt");
}

function iGpxDetailIdxFromOnKeyDown(e){
  if(e.which==13) {
    console.log('iGpxDetailIdxFromOnKeyDown(): Xindex='+Xindex);
    iGpxDetailIdxSpinner();
  }
}
function iGpxDetailIdxSpinner(){
  Xindex=$("#iGpxDetailIdxFrom").val()-0; //index pocatecniho bodu
  console.log('iGpxDetailIdxSpinner(): Xindex='+Xindex);
  GpxFillDetail();
}


function GpxFillDetail(){ //vyplneni tabulky s podrobnostmi
  saveGpxSettings(); //napred ulozime nastaveni, pro pripad, ze se zmenilo

  //console.log('Index bodu od: '+(Xindex-1)+"    do: "+Xindex);
  if(Xindex<1) Xindex=1;
  if(Xindex>=aTrack.length) Xindex=aTrack.length-1;
  idx=Xindex-1; //Xindex je od 1, ale index od 0
  //zobrazime hodnoty s poradim bodu
  //console.log('GpxFillDetail() Xindex='+Xindex);
  //nastavime hodnotu value v <input>, od 1, aby to bylo jako v tooltipu grafu
  $("#iGpxDetailIdxFrom").val(Xindex);
  //nastavime poradi koncoveho bodu (2. <td> v radku)
  $("#iGpxDetaiIdxTo").html((Xindex+1)+"");
  s='<th>Lat</th><td>'+aTrack[idx].lat.toFixed(6)+'</td><td>'+aTrack[idx+1].lat.toFixed(6)+'</td>'
  $("#iGpxDetailLat").html(s);
  s='<th>Lon</th><td>'+aTrack[idx].lon.toFixed(6)+'</td><td>'+aTrack[idx+1].lon.toFixed(6)+'</td>'
  $("#iGpxDetailLon").html(s);
  s="<th>Čas</th><td>"+dateFormat(aTrack[idx].time,"dd.mm.yyyy<br />HH:MM:ss")
    +"</td><td>"+dateFormat(aTrack[idx+1].time,"dd.mm.yyyy<br />HH:MM:ss")+"</td>";
  $("#iGpxDetailTime1").html(s);
  s="<th>Doba</th><td>"+formaTimeDifference(aTrack[idx].time/1000-aTrack[0].time/1000)+"</td>"
    +'<td>'+formaTimeDifference(aTrack[idx+1].time/1000-aTrack[0].time/1000)+"</td>";
  $("#iGpxDetailTime2").html(s);
  s="<th>Vzdálenost [km]</th><td>"+(aTrack[idx].dist/1000).toFixed(3)+"</td>"
    +'<td>'+(aTrack[idx+1].dist/1000).toFixed(3)+"</td>";
  $("#iGpxDetailDist").html(s);
  s="<th>Nadm.výška [m]</th><td>"+aTrack[idx].ele.toFixed(2)+"</td>"
    +'<td>'+(aTrack[idx+1].ele).toFixed(2)+"</td>";
  $("#iGpxDetailEle").html(s);
  s="<th>Rychlost</th><td colspan=2>"+aTrack[idx+1].speed.toFixed(2)+" km/h</td>";
  $("#iGpxDetailSpeed").html(s);
  s="<th>Δ času</th><td colspan=2>"+aTrack[idx+1].dTime+" s</td>";
  $("#iGpxDetailDTime").html(s);
  s="<th>Δ vzdálenosti</th><td colspan=2>"+aTrack[idx+1].dDist.toFixed(2)+" m</td>";
  $("#iGpxDetailDDist").html(s);
  s="<th>Δ výšky</th><td colspan=2>"+aTrack[idx+1].dEle.toFixed(2)+" m</td>";
  $("#iGpxDetailDEle").html(s);

  //nakreslime zvyraznenou caru mezi dvema zobrazenymi body
  //console.log('GpxLine='+typeof GpxLine);
  if(typeof GpxLine!=="undefined") map.removeLayer(GpxLine);
  var aLatLon=[];
  aLatLon.push([aTrack[idx].lat,aTrack[idx].lon]);
  aLatLon.push([aTrack[idx+1].lat,aTrack[idx+1].lon]);
  GpxColorBold=$('#iSettingsColorBold').val();
  GpxWeightBold=$('#iSettingsWeightBold').val();
  //console.log('GpxLine='+GpxColorBold+', '+GpxWeightBold);
  GpxLine=L.polyline(aLatLon, {color:GpxColorBold , weight: GpxWeightBold, smoothFactor: 1, zIndex: 501}).addTo(map);
}

function addForms() {
	div='<div id="iGpxForm" class="noprint leaflet-control-layers movable">'
      +'<img id="iGpxLoad" title="Zobrazení GPX souboru se stopou" alt="Zobrazení GPX souboru se stopou" src="plugin/GpxFile/gpx-24.png" />'
      +'<img id="iGpxEdit" title="Zobrazení GPX souboru se stopou s možností úpravy" alt="Načtení GPX souboru se stopou s možností úpravy" src="plugin/GpxFile/edit.png" />'
      +'<img id="iGpxButSettings" class="cDisable" title="Nastavení vlastností zobrazené stopy" alt="Nastavení vlastností zobrazené stopy" src="plugin/GpxFile/transparent-24.png" />'
      +'<img id="iGpxButTable" class="cDisable" title="Zobrazení/skrytí tabulky s přehledem o stopě" alt="Zobrazení/skrytí tabulky s přehledem o stopě" src="plugin/GpxFile/transparent-24.png" />'
      +'<img id="iGpxButGraph" class="cDisable" title="Zobrazení/skrytí grafu stopy" alt="Zobrazení/skrytí grafu stopy" src="plugin/GpxFile/transparent-24.png" />'
//	    +'<div class="movable-corner"></div>'
	    +'</div>'
      //cast pouzita pro ukladani do souboru, neni zobrazeno, ale pouziva se
      +'<div style="display:none;"><textarea id="iGpxTxt"></textarea>'
      //+'<button id="create"></button>  //tohle asi neni potreba
      +'</div>'
      //cast pouzita pro volbu typu ulozeneho souboru
      +'<div id="iGpxSaveForm" class="noprint">'
      +'<div id="iGpxSaveTitle">Uložit jako ...<a class="close" onclick="hideGpxSaveForm();">×</a></div>'
      +'<p><span id="iGpxSaveId"></span>' //id objektu, ktery prijde ulozit
      +'<button onclick="saveCoords(1);">Stopu</button><br />'
      +'<button onclick="saveCoords(2);">Trasu</button><br />'
      +'<button onclick="saveCoords(4);">GeoJSON</button><br />'
      +'<button onclick="saveCoords(0);">CSV (SS.dddddd)</button><br />'
      +'<button onclick="saveCoords(3);">CSV (SS°MM.ddd)</button><br />'
      +'</p></div>'
      ;
  $('#filter-panel').after(div); //vlozime div s ikonkou
  //vytvorime div pro textovy prehled o stope
  div='<div id="iGpxFormDivTrackTable" class="noprint movable cDisable">'
     +'<table id="iGpxFormTrackTable">'
     +'<tr><th colspan=2>Přehled o načtené stopě</th></tr>'
     +'<tr><th>Počet bodů</th><td id="iGpxFormTdCount"></td></tr>'

     +'<tr><th colspan=2>Časy</th></tr>'
     +'<tr><th>Startu</th><td id="iGpxFormTdTmStart"></td></tr>'
     +'<tr><th>Cíle</th><td id="iGpxFormTdTmEnd"></td></tr>'
     +'<tr><th>Celkový čas</th><td id="iGpxFormTdTmTotal"></td></tr>'
     +'<tr><th>Doba pohybu</th><td id="iGpxFormTdTmMove"></td></tr>'
     +'<tr><th>Doba stání</th><td id="iGpxFormTdTmStop"></td></tr>'
     +'<tr><th>Doba stoupání</th><td id="iGpxFormTdTmUp"></td></tr>'
     +'<tr><th>Doba klesání</th><td id="iGpxFormTdTmDown"></td></tr>'
     +'<tr><th>Doba po rovině</th><td id="iGpxFormTdTmLevel"></td></tr>'

     +'<tr><th colspan=2>Vzdálenosti</th></tr>'
     +'<tr><th>Celková plošná</th><td id="iGpxFormTdDist"></td></tr>'
     +'<tr><th>Celková reálná</th><td id="iGpxFormTdDistReal"></td></tr>'
     +'<tr><th>Stoupání</th><td id="iGpxFormTdDistUp"></td></tr>'
     +'<tr><th>Klesání</th><td id="iGpxFormTdDistDown"></td></tr>'
     +'<tr><th>Po rovině</th><td id="iGpxFormTdDistLevel"></td></tr>'

     +'<tr><th colspan=2>Rychlosti</th></tr>'
     +'<tr><th>Maximální</th><td id="iGpxFormTdSpeedMax"></td></tr>'
     +'<tr><th>Průměrná</th><td id="iGpxFormTdSpeedAvg"></td></tr>'
     +'<tr><th>Pohybu</th><td id="iGpxFormTdSpeedMove"></td></tr>'
     +'<tr><th>Stoupání</th><td id="iGpxFormTdSpeedUp"></td></tr>'
     +'<tr><th>Klesání</th><td id="iGpxFormTdSpeedDown"></td></tr>'
     +'<tr><th>Po rovině</th><td id="iGpxFormTdSpeedLevel"></td></tr>'

     +'<tr><th colspan=2>Nadmořské výšky</th></tr>'
     +'<tr><th>Počátku</th><td id="iGpxFormTdHighStart"></td></tr>'
     +'<tr><th>Konce</th><td id="iGpxFormTdHighEnd"></td></tr>'
     +'<tr><th>Rozdíl</th><td id="iGpxFormTdHighDelA"></td></tr>'
     +'<tr><th>Minimální</th><td id="iGpxFormTdHighMin"></td></tr>'
     +'<tr><th>Maximální</th><td id="iGpxFormTdHighMax"></td></tr>'
     +'<tr><th>Rozdíl</th><td id="iGpxFormTdHighDelB"></td></tr>'
     +'<tr><th>Nastoupáno</th><td id="iGpxFormTdHighUp"></td></tr>'
     +'<tr><th>Naklesáno</th><td id="iGpxFormTdHighDown"></td></tr>'
     +'<tr><th>Rozdíl</th><td id="iGpxFormTdHighDelC"></td></tr>'
     +'</table>'
     +'</div>';
  $('#iGpxForm').after(div); //vlozime div s tabulkou
    //okno pro grafy
  div='<div id="iGpxFormDivTrackGraph" class="cDisable noprint leaflet-control-layers movable">'
    +'<div id="iGpxFormDivTrackGraphHT"></div>'
    +'<div id="iGpxFormDivTrackGraphTable">'
     +'<table id="iGpxFormDivDetailTable">'
     +'<tr><th colspan=3>Přehled o vybraném úseku<br/>(po kliknutí do grafu)</th></tr>'
     +'<tr><th>&nbsp;</th><th>Od</th><th>Do</th></tr>'
     +'<tr id="iGpxDetailIdx"><th>Pořadí bodu</th><td>'
     +  '<input id="iGpxDetailIdxFrom" type="number" min="0" max="100" value="" />'
     +  '</td><td id="iGpxDetaiIdxTo"></td></tr>'
     +'<tr id="iGpxDetailLat"><th>Lat</th><td></td><td></td></tr>'
     +'<tr id="iGpxDetailLon"><th>Lon</th><td></td><td></td></tr>'
     +'<tr id="iGpxDetailTime1"><th>Čas</th><td></td><td></td></tr>'
     +'<tr id="iGpxDetailTime2"><th>Doba</th><td></td><td></td></tr>'
     +'<tr id="iGpxDetailDist"><th>Vzdálenost</th><td></td><td></td></tr>'
     +'<tr id="iGpxDetailEle"><th>Nadm.výška</th><td></td><td></td></tr>'
     +'<tr id="iGpxDetailSpeed"><th>Rychlost</th><td colspan=2></td></tr>'
     +'<tr id="iGpxDetailDTime"><th>Δ času</th><td colspan=2></td></tr>'
     +'<tr id="iGpxDetailDDist"><th>Δ vzdálenosti</th><td colspan=2></td></tr>'
     +'<tr id="iGpxDetailDEle"><th>Δ výšky</th><td colspan=2></td></tr>'
     +'</table>'
    +'</div>'
    //+'<br/><input type="number" min="0" value="50" maxlength="20" />'
    +'</div>';
  $('#iGpxFormDivTrackTable').after(div); //vlozime div s grafy
  //div pro nastaveni vlastnosti pluginu
	div='<div id="iGpxDivSettings" class="noprint leaflet-control-layers cDisable">'
      +'<div id="iGpxClose"><img src="plugin/GpxFile/transparent-24.png" /></div>'
      +'<h2>Nastavení GpxFile</h2>'
      +'<span class="cSettingsProp">Barva stopy (blue, #123456, rgb(xr,g,b),...):</span>'
      +  '<input type="text" id="iSettingsColor" maxlength="50" size="8" value="'+GpxColor+'" /><br/>'
      +'<span class="cSettingsProp">Šířka stopy:</span>'
      +  '<input type="text" id="iSettingsWeight" maxlength="3" size="8" value="'+GpxWeight+'" /><br/>'
      +'<span class="cSettingsProp">Barva zvýrazněného úseku stopy:</span>'
      +  '<input type="text" id="iSettingsColorBold" maxlength="50" size="8" value="'+GpxColorBold+'" /><br/>'
      +'<span class="cSettingsProp">Šířka zvýrazněného úseku:</span>'
      +  '<input type="text" id="iSettingsWeightBold" maxlength="3" size="8" value="'+GpxWeightBold+'" /><br/>'
      +'<span class="cSettingsProp">% sklonu, který je ještě pohyb po rovině <sup>1)</sup>:</span>'
      +  '<input type="text" id="iSettingsTilt" maxlength="3" size="8" value="0.5"/><br/>'
      +'<span class="cSettingsProp">Max. rychlost platných úseků [km/h] <sup>1,2)</sup>:</span>'
      +  '<input type="text" id="iSettingsSpeed" maxlength="3" size="8" value="0"/><br/>'
      +'<input type="checkbox" id="iSettingsClick" />'
      +  '<span class="cSettingsProp">Pohyb myši v grafu se bez kliknutí promítá do podrobností</span><br/>'
      +'<br/>'
      +'<table class="cSettingsNoteLR">'
      +  '<tr><td><sup>1)</sup> jen po novém načtení stopy</td>'
      +  '<td><sup>2)</sup> 0 kontrolu vvypíná</td><tr></table>'
      +'<span class="cSettingsNote">Změna hodnot se projeví po novém načtení stopy nebo pro '
      +  'zobrazenou stopu po kliknutí na tlačítko <b>Použít</b>.</span><br/>'
      +'<div class="cSettingsButton"><button id="iGpxChangeTrack">Použít</button></div>'
      +'<br><br>Test vkladani cisla: <input type="number" min="0" max="4000" size="6" value="100" />'
      +'</div>';
  $('#iGpxFormDivTrackGraph').after(div); //vlozime div s snastavenim

  //obsluha tlacitka pro zmenu stopy
	$("#iGpxChangeTrack").click(function(){
    if(typeof GpxPoly==="undefined"){
      alert("Není načtena žádná stopa, nastavené hodnoty budou použity pro nově načtenou stopu.");
      return;
    }
    saveGpxSettings(); //pro pripad, ze se nastaveni zmenilo, ulozime ho
    //zmenime vlastnosti stopy
    GpxWeight=$('#iSettingsWeight').val();
    GpxColor=$('#iSettingsColor').val();
    GpxPoly.setStyle({color: GpxColor, weight: GpxWeight});
    if(typeof GpxLine!=="undefined"){
      GpxWeightBold=$('#iSettingsWeightBold').val();
      GpxColorBold=$('#iSettingsColorBold').val();
      GpxLine.setStyle({color: GpxColorBold, weight: GpxWeightBold});
    }
	});
 	// obsluha tlacitka Load GPX
	$("#iGpxLoad").click(function(){
    var input=document.createElement('input');
    input.type='file';
    input.onchange = e => {
      parseGpx(e.target.files[0],false);   //pridame bez moznosti editace
    };
    input.click();
	});
  $("#iGpxEdit").click(function(){
    var input=document.createElement('input');
    input.type='file';
    input.onchange = e => {
      parseGpx(e.target.files[0],true);   //pridame s moznosti editace
    };
    input.click();
  });
	$("#iGpxButTable").click(function(){  //skryjeme nebo zobrazime tabulku
    if($('#iGpxFormTdCount').html()!=""){
      $('#iGpxFormDivTrackTable').toggleClass('cDisable');
      $('#iGpxButTable').toggleClass('cDisable');
    }
	});
	$("#iGpxButGraph").click(function(){  //skryjeme nebo zobrazime tabulku
    if($('#iGpxFormTdCount').html()!=""){
      $('#iGpxFormDivTrackGraph').toggleClass('cDisable');
      $('#iGpxButGraph').toggleClass('cDisable');
    }
	});
	$("#iGpxButSettings").click(function(){  //skryjeme nebo zobrazime tabulku
    $('#iGpxButSettings').toggleClass('cDisable');
    $('#iGpxDivSettings').toggleClass('cDisable');
    bGpxSave=true;
	});
	$("#iGpxClose").click(function(){  //skryjeme nebo zobrazime tabulku
    $('#iGpxButSettings').toggleClass('cDisable');
    $('#iGpxDivSettings').toggleClass('cDisable');
	});
  //zmena indexu bodu pro vykresleni detailu
  $('#iGpxDetailIdxFrom').keydown(function(e){
    iGpxDetailIdxFromOnKeyDown(e);
  });
  $("#iGpxDetailIdxFrom").on('change mousewheel', function(e){
    iGpxDetailIdxSpinner();
  });

  //obsluha vytvoreni noveho kresleneho objektu tak, abych ho pripadne mohl ulozit
  //(prida na radek tabulky v Draws ikonku pro ulozeni)
  map.on(L.Draw.Event.CREATED, function (poly) {
    var eTr=document.getElementById('ftr_'+lineCounter_);
    //pred vzdalenost pridame novy td s tlacitkem pro ulozeni
    //element pridavame vzdy, ale to tlacitko jen pro polyline
    var tdSave = document.createElement("td");
    eTr.insertBefore(tdSave,eTr.lastElementChild);
    if(poly.layerType=="polyline" || poly.layerType=="polygon"){
      tdSave.innerHTML='<div class="cGpxButSave" onclick="saveAsFile('
        +poly.layer._leaflet_id+');"></div>';
    }
    if(poly.layerType=="marker"){
      tdSave.innerHTML='<div class="cGpxButSave" onclick="saveMarkers();"></div>';
      GpxFile_markers.push(poly.layer._leaflet_id);
    }
    if(poly.layerType=="circle"){
      tdSave.innerHTML='<div class="cGpxButSave" onclick="saveCircles();"></div>';
      GpxFile_circles.push(poly.layer._leaflet_id);
    }
  });
  // ---- nacteme knihovnu pro kresleni grafu, stejnou jako pro Stator
  var script=document.createElement("SCRIPT");
  script.src='https://geocaching.cz/stator/js/echarts.min.js';
  script.type='text/javascript';
  document.getElementsByTagName("head")[0].appendChild(script);
}

//seznam vsech id, kde je hodnota k ulozeni/nacteni
var aSettingsItemsStr=['iSettingsColor','iSettingsWeight','iSettingsColorBold',
  'iSettingsWeightBold','iSettingsTilt','iSettingsSpeed'];
var aSettingsItemsCheck=['iSettingsClick'];

function saveGpxSettings(){
  if(!bGpxSave) return; //neni treba ukladat
  aSettingsItemsStr.forEach(sId=>{
    localStorage.setItem('GpxFile_'+sId, $('#'+sId).val());
  });
  aSettingsItemsCheck.forEach(sId=>{
    var s;
    if($('#'+sId).is(":checked")) s="Yes"; else s="No";
    localStorage.setItem('GpxFile_'+sId,s);
    //console.log('saveGpxSettings(): GpxFile_'+sId+'->'+s);
  });
  bGpxSave=false;
}

function loadGpxSettings(){
  aSettingsItemsStr.forEach(sId=>{
    var s=localStorage.getItem('GpxFile_'+sId);
    //console.log('loadGpxSettings(): str-'+sId+'='+s);
    if(s!='undefined' && s!='') $('#'+sId).val(s);
  });
  aSettingsItemsCheck.forEach(sId=>{
    var b=localStorage.getItem('GpxFile_'+sId);
    $('#'+sId).prop('checked',(b=="Yes"));
  });
}

function GpxFile_ggm_init() {
  //cislo verze, aby se po instalaci aktualizoval i css soubor
  //a nebylo treba rucne CTRL+F5
	loadcss('plugin/GpxFile.css?ver=27.8.2021');
	ggmregister('onmap', function() {
		addForms();
    loadGpxSettings(); //nacteme drive ulozene nastaveni
	});
	//ggmregister('onclear', function() { //tohle maze pole i jindy nez pred ukoncenim mapy
  //  GpxFileTrackAnalyseClean();
  //});
}

////////////////////////////////////////////////////////////////////////////////
//https://stevenlevithan.com/assets/misc/date.format.js
/*
 * Date Format 1.2.3
 * (c) 2007-2009 Steven Levithan <stevenlevithan.com>
 * MIT license
 *
 * Includes enhancements by Scott Trenda <scott.trenda.net>
 * and Kris Kowal <cixar.com/~kris.kowal/>
 *
 * Accepts a date, a mask, or a date and a mask.
 * Returns a formatted version of the given date.
 * The date defaults to the current date/time.
 * The mask defaults to dateFormat.masks.default.
 */

var dateFormat = function () {
	var	token = /d{1,4}|m{1,4}|yy(?:yy)?|([HhMsTt])\1?|[LloSZ]|"[^"]*"|'[^']*'/g,
		timezone = /\b(?:[PMCEA][SDP]T|(?:Pacific|Mountain|Central|Eastern|Atlantic) (?:Standard|Daylight|Prevailing) Time|(?:GMT|UTC)(?:[-+]\d{4})?)\b/g,
		timezoneClip = /[^-+\dA-Z]/g,
		pad = function (val, len) {
			val = String(val);
			len = len || 2;
			while (val.length < len) val = "0" + val;
			return val;
		};

	// Regexes and supporting functions are cached through closure
	return function (date, mask, utc) {
		var dF = dateFormat;

		// You can't provide utc if you skip other args (use the "UTC:" mask prefix)
		if (arguments.length == 1 && Object.prototype.toString.call(date) == "[object String]" && !/\d/.test(date)) {
			mask = date;
			date = undefined;
		}

		// Passing date through Date applies Date.parse, if necessary
		date = date ? new Date(date) : new Date;
		if (isNaN(date)) throw SyntaxError("invalid date");

		mask = String(dF.masks[mask] || mask || dF.masks["default"]);

		// Allow setting the utc argument via the mask
		if (mask.slice(0, 4) == "UTC:") {
			mask = mask.slice(4);
			utc = true;
		}

		var	_ = utc ? "getUTC" : "get",
			d = date[_ + "Date"](),
			D = date[_ + "Day"](),
			m = date[_ + "Month"](),
			y = date[_ + "FullYear"](),
			H = date[_ + "Hours"](),
			M = date[_ + "Minutes"](),
			s = date[_ + "Seconds"](),
			L = date[_ + "Milliseconds"](),
			o = utc ? 0 : date.getTimezoneOffset(),
			flags = {
				d:    d,
				dd:   pad(d),
				ddd:  dF.i18n.dayNames[D],
				dddd: dF.i18n.dayNames[D + 7],
				m:    m + 1,
				mm:   pad(m + 1),
				mmm:  dF.i18n.monthNames[m],
				mmmm: dF.i18n.monthNames[m + 12],
				yy:   String(y).slice(2),
				yyyy: y,
				h:    H % 12 || 12,
				hh:   pad(H % 12 || 12),
				H:    H,
				HH:   pad(H),
				M:    M,
				MM:   pad(M),
				s:    s,
				ss:   pad(s),
				l:    pad(L, 3),
				L:    pad(L > 99 ? Math.round(L / 10) : L),
				t:    H < 12 ? "a"  : "p",
				tt:   H < 12 ? "am" : "pm",
				T:    H < 12 ? "A"  : "P",
				TT:   H < 12 ? "AM" : "PM",
				Z:    utc ? "UTC" : (String(date).match(timezone) || [""]).pop().replace(timezoneClip, ""),
				o:    (o > 0 ? "-" : "+") + pad(Math.floor(Math.abs(o) / 60) * 100 + Math.abs(o) % 60, 4),
				S:    ["th", "st", "nd", "rd"][d % 10 > 3 ? 0 : (d % 100 - d % 10 != 10) * d % 10]
			};

		return mask.replace(token, function ($0) {
			return $0 in flags ? flags[$0] : $0.slice(1, $0.length - 1);
		});
	};
}();

// Some common format strings
dateFormat.masks = {
	"default":      "ddd mmm dd yyyy HH:MM:ss",
	shortDate:      "m/d/yy",
	mediumDate:     "mmm d, yyyy",
	longDate:       "mmmm d, yyyy",
	fullDate:       "dddd, mmmm d, yyyy",
	shortTime:      "h:MM TT",
	mediumTime:     "h:MM:ss TT",
	longTime:       "h:MM:ss TT Z",
	isoDate:        "yyyy-mm-dd",
	isoTime:        "HH:MM:ss",
	isoDateTime:    "yyyy-mm-dd'T'HH:MM:ss",
	isoUtcDateTime: "UTC:yyyy-mm-dd'T'HH:MM:ss'Z'"
};

// Internationalization strings
dateFormat.i18n = {
	dayNames: [
		"Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat",
		"Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"
	],
	monthNames: [
		"Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec",
		"January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"
	]
};

// For convenience...
Date.prototype.format = function (mask, utc) {
	return dateFormat(this, mask, utc);
};
///////////////////////////////////////////////////////////////////////////////
